Foreman - Tracker #29939

Improve setting definition DSL and move setting registry to memory
05/27/2020 10:19 AM - Ondrej Ezr

Status: Closed % Done: 100%
Priority: Normal

Assignee: Ondrej Ezr

Category: Settings

Target version:

Difficulty: medium Fixed in Releases: 3.6.0
Triaged: Yes Found in Releases:

Bugzilla link: Red Hat JIRA:

Description

Currently we have all the settings (both changed and unchanged) in the database, but we have all the defaults in code as well, so it

makes no sense to have quite a heavy code base to keep both in sync.

Instead I'd like to bring the setting inventory into memory and database would keep only the changed settings.

It should give as an easy way for plugins to extend settings category not just adding a new one.

Subtasks:
Refactor # 30860: Create SettingPresenter as a proxy for setting Ul values Closed
Refactor # 30861: Move setting value collections to SettingPresenter Closed
Feature # 30862: Introduce SettingRegistry as a setting inventory Closed
Refactor # 31471: Deprecate setting timestamps in API responses Closed
Feature # 32286: Create a new setting definition DSL Closed
Refactor # 32287: Load Setting index page from memory registry Closed
Refactor # 32403: Add custom validations to new setting DSL Closed
Refactor # 32408: Use new DSL to define settings Closed
Refactor # 11836: Rename Puppet settings to Configuration Closed
Refactor # 32893: Use new DSL to define General settings Closed
Refactor # 33589: Use new DSL to define Authentication settings Closed
Refactor # 33595: Use new DSL to define Email settings Closed
Refactor # 33596: Use new DSL to define Notification settings Closed
Refactor # 33601: Use new DSL to define Provisioning settings Closed
Refactor # 33607: Use new DSL to define Puppet settings Closed
Refactor # 32415: Use only SettingRegistry to read and update the settings Closed
Bug # 32489: Setting registry doesn't reload properly on autoreload Closed
Refactor # 32583: Mandatory setting type Duplicate
Refactor # 32894: Add strong typing to Setting DSL Closed
Refactor # 33608: use new Settings DSL in Katello Closed
Refactor # 33781: Deprecate the old setting definitions without "default_settings" Closed
Refactor # 33782: Initialize Setting for tests without fixtures Closed
Refactor # 34305: Stop creating settings in the DB Closed
Bug # 34328: GraphQL is using Setting model directly Closed
Refactor # 34335: Make GraphQL read settings from Registry Rejected
Refactor # 34603: Deprecate other than DSL setting definitions Closed
Refactor # 35013: Refactor config rake to use Setting DSL Closed
Refactor # 35793: Drop the settings category column from database Closed
Related issues:
Related to Katello - Refactor #30354: Use only public setting interface to up... Closed
Related to Foreman - Refactor #29257: remove x-editable-rails Closed
Related to Foreman - Bug #33791: Settings defined in settings.yaml do not tak... Closed
Related to Boot disk - Refactor #34674: Use new DSL to define settings

Related to Discovery - Refactor #34677: Use new DSL to define settings

Blocks Ansible - Refactor #32409: Use new DSL to define settings

Blocks Templates - Refactor #32410: Use new DSL to define settings

Blocks Discovery - Refactor #32411: Remove the old Setting class, which now o...

Blocks foreman-tasks - Refactor #32412: Use new DSL to define settings

Blocks Foreman Remote Execution - Refactor #32413: Use new DSL to define sett...

Blocks Statistics - Refactor #32414: Use new DSL to define settings

Closed
Closed
Closed
Closed
New

Closed
Closed
Closed

Associated revisions

Revision ¢791f6c7 - 01/16/2023 12:01 PM - Ondfiej Ezr
Fixes #29939 - drop category column from settings
Settings table was holding category column to support old style of

settings, but it is now ready to be decomissioned as plugins were given
enough time.

History

#1 - 05/28/2020 11:12 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/7702 added

#2 - 07/09/2020 11:28 AM - Ondfej Ezr

- Related to Refactor #30354: Use only public setting interface to update setting values added

#3 - 09/07/2020 01:19 PM - Amit Upadhye
- Target version changed from 2.2.0 to 2.3.0

#4 - 09/16/2020 03:28 PM - Ondfej Ezr

- Subject changed from Add extension point to setting defaults to Move setting registry into a memory

#5 - 09/16/2020 03:31 PM - Ondfej Ezr

- Description updated

#6 - 09/16/2020 03:32 PM - Ondfej Ezr
- Tracker changed from Feature to Tracker
- % Done setto 0

- Pull request deleted (https://github.com/theforeman/foreman/pull/7702)

#7 - 09/17/2020 10:38 AM - Ondfej Ezr

- Description updated

#8 - 09/17/2020 10:39 AM - Ondrej Ezr
- Related to Refactor #29257: remove x-editable-rails added

#9 - 11/23/2020 11:29 AM - Ondrej Ezr
- Target version changed from 2.3.0 to 2.4.0

#10 - 01/27/2021 01:56 PM - Tomer Brisker
- Target version deleted (2.4.0)

#11 - 02/02/2021 01:05 PM - Amit Upadhye

- Target version set to 2.5.0

#12 - 04/10/2021 10:22 PM - Ondfej Ezr

- Subject changed from Move setting registry into a memory to Improve setting definition DSL and move setting registry to memory
#13 - 04/24/2021 08:36 PM - Ondrej Ezr
- Blocks Refactor #32409: Use new DSL to define settings added

#14 - 04/24/2021 08:37 PM - Ondrej Ezr
- Blocks Refactor #32410: Use new DSL to define settings added

#15 - 04/24/2021 08:38 PM - Ondrej Ezr
- Blocks Refactor #32411: Remove the old Setting class, which now only holds helper methods added

#16 - 04/24/2021 08:39 PM - Ondfiej Ezr
- Blocks Refactor #32412: Use new DSL to define settings added

#17 - 04/24/2021 08:40 PM - Ondrej Ezr
- Blocks Refactor #32413: Use new DSL to define settings added

#18 - 04/24/2021 08:41 PM - Ondrej Ezr
- Blocks Refactor #32414: Use new DSL to define settings added

#19 - 04/26/2021 09:13 AM - Ondfiej Ezr
- Target version deleted (2.5.0)

#20 - 10/27/2021 08:18 AM - Ondfiej Ezr
- Related to Bug #33791: Settings defined in settings.yaml do not take precedence in the new DSL added

#21 - 03/24/2022 05:01 PM - Ondrej Ezr
- Related to Refactor #34674: Use new DSL to define settings added

#22 - 06/03/2022 07:00 AM - Ondfej Ezr
- Related to Refactor #34677: Use new DSL to define settings added

#23 - 01/16/2023 12:01 PM - The Foreman Bot
- Fixed in Releases 3.6.0 added

#24 - 01/16/2023 01:01 PM - Ondfej Ezr
- Status changed from Ready For Testing to Closed
- % Done changed from 95 to 100

Applied in changeset foreman|c791f6c70806952aef520cc779397560138f207e.
